const Main = imports.ui.main;
const Magnifier = imports.ui.magnifier;
const Lang = imports.lang;
const PointerWatcher = imports.ui.pointerWatcher;
const AppDisplay = imports.ui.appDisplay;
const Mainloop = imports.mainloop;
const GLib = imports.gi.GLib;

const MAGNIFIER_FREQUENCY = 10;
const CURSOR_UPDATE_FREQUENCY = 100;

let injections = [];
let timeoutId;

function applyChanges(){
	Main.magnifier.stopTrackingMouse();
	Main.magnifier.startTrackingMouse();
	Main.overview.viewSelector.appDisplay._views[1].view._redisplay();
}

function enable(){
	injections['startTrackingMouse'] = Magnifier.Magnifier.prototype.startTrackingMouse;
	Magnifier.Magnifier.prototype.startTrackingMouse = function(){
		if (!this._pointerWatch)
            this._pointerWatch = PointerWatcher.getPointerWatcher().addWatch(MAGNIFIER_FREQUENCY, Lang.bind(this, this.scrollToMousePos));
			timeoutId = Mainloop.timeout_add(CURSOR_UPDATE_FREQUENCY, Lang.bind(this, function(){
				this._updateMouseSprite();
		        return GLib.SOURCE_CONTINUE;
			}));
	}
	injections['adaptToSize'] = AppDisplay.AllView.prototype.adaptToSize;
	AppDisplay.AllView.prototype.adaptToSize = function(width, height){
        injections['adaptToSize'].call(this, width, height);
        this._scrollView.update_fade_effect(0, 0);
	};
	applyChanges();
}

function disable(){
	Magnifier.Magnifier.prototype.startTrackingMouse = injections['startTrackingMouse'];
	Mainloop.source_remove(timeoutId); 
	AppDisplay.AllView.prototype.adaptToSize = injections['adaptToSize'];
	applyChanges();
}

function init(){}